searchData={"items":[{"type":"task","title":"mix test.interactive","doc":"Interactive test runner for ExUnit tests.\n\n`mix test.interactive` allows you to easily switch between running all tests,\nstale tests, or failed tests. Or, you can run only the tests whose filenames\ncontain a substring. Includes an optional \"watch mode\" which runs tests after\nevery file change.","ref":"Mix.Tasks.Test.Interactive.html"},{"type":"task","title":"Usage - mix test.interactive","doc":"```shell\nmix test.interactive [options] pattern...\n```\n\nYour tests will run immediately (and every time a file changes).","ref":"Mix.Tasks.Test.Interactive.html#module-usage"},{"type":"task","title":"Options - mix test.interactive","doc":"`mix test.interactive` understands the following options:\n- `--no-watch`: Don't run tests when a file changes\n\nAll other options are passed through to `mix test` on every test run.\n\n`mix test.interactive` will detect the `--stale` and `--failed` flags and use\nthose as initial settings in interactive mode. You can then toggle those flags\non and off as needed.","ref":"Mix.Tasks.Test.Interactive.html#module-options"},{"type":"task","title":"Patterns and filenames - mix test.interactive","doc":"`mix test.interactive` can take the same filename or filename:line_number\npatterns that `mix test` understands. It also allows you to specify one or\nmore \"patterns\" - strings that match one or more test files. When you provide\none or more patterns on the command-line, `mix test.interactive` will find all\ntest files matching those patterns and pass them to `mix test` as if you had\nused the `p` command (described below).","ref":"Mix.Tasks.Test.Interactive.html#module-patterns-and-filenames"},{"type":"task","title":"Interactive Commands - mix test.interactive","doc":"After the tests run, you can use the interactive mode to change which tests\nwill run.\n\n- `a`: Run all tests.\n- `f`: Run only tests that failed on the last run (equivalent to the\n`--failed` option of `mix test`).\n- `p`: Run only test files that match one or more provided patterns. A pattern\nis the project-root-relative path to a test file (with or without a line\nnumber specification) or a string that matches a portion of full pathname.\ne.g. `test/my_project/my_test.exs`, `test/my_project/my_test.exs:12:24` or\n`my`.\n- `q`: Exit the program. (Can also use `Ctrl-D`.)\n- `s`: Run only test files that reference modules that have changed since the\nlast run (equivalent to the `--stale` option of `mix test`).\n- `w`: Turn file-watching mode on or off.\n- `Enter`: Re-run the current set of tests without requiring a file change.","ref":"Mix.Tasks.Test.Interactive.html#module-interactive-commands"},{"type":"task","title":"Configuration - mix test.interactive","doc":"If your project has a `config/config.exs` file, you can customize the\noperation of `mix test.interactive` with the following settings:\n\n- `clear: true`: Clear the console before each run (default: `false`).\n- `exclude: [patterns...]`: A list of `Regex`es to ignore when watching for\n  changes (default: `[~r/.#/, ~r{priv/repo/migrations}]`).\n- `task:  `: The mix task to use when running tests (default:\n  `\"test\"`).","ref":"Mix.Tasks.Test.Interactive.html#module-configuration"},{"type":"function","title":"Mix.Tasks.Test.Interactive.run/1","doc":"","ref":"Mix.Tasks.Test.Interactive.html#run/1"},{"type":"module","title":"MixTestInteractive","doc":"Interactively run your Elixir project's tests.","ref":"MixTestInteractive.html"},{"type":"function","title":"MixTestInteractive.run/1","doc":"Start the interactive test runner.","ref":"MixTestInteractive.html#run/1"},{"type":"behaviour","title":"MixTestInteractive.Command","doc":"Behaviour for interactive mode commands.\n\nAll commands must implement this behaviour.\n\nIt is recommended to `use` this module in the command's module:\n\n```\ndefmodule MyCommand do\n  use MixTestInteractive.Command,\n    command: \"c\",\n    desc: \"do the thing\"\n\n  # ...\nend\n```\n\nThis will provide overridable implementations of most of the callbacks.\n\n`:command` is the key sequence the user will use to invoke the command. If a more appropriate\ncommand name is required in the help text, you can override the `name/0` callback.\n\n`:desc` is the command's description.\n\n`:command` and `:desc` should be written so that the following pattern reads nicely in the\nusage output: `  to  `. For example, `a to run all tests`.","ref":"MixTestInteractive.Command.html"},{"type":"callback","title":"MixTestInteractive.Command.applies?/1","doc":"Is the command applicable given the current configuration?\n\nReturns `true` by default if not overridden.","ref":"MixTestInteractive.Command.html#c:applies?/1"},{"type":"callback","title":"MixTestInteractive.Command.command/0","doc":"The command's key sequence.\n\nKey sequences should be short (single character preferred) and unique.\n\nReturns the value of the `:command` argument passed in the `use` statement.\n\nNot overridable.","ref":"MixTestInteractive.Command.html#c:command/0"},{"type":"callback","title":"MixTestInteractive.Command.description/0","doc":"The command's description.\n\nDescriptions should be written to fit the pattern `  to  `.\nFor example, `a to run all tests`.\n\nReturns the value of the `:desc` argument passed in the `use` statement.\n\nNot overridable.","ref":"MixTestInteractive.Command.html#c:description/0"},{"type":"callback","title":"MixTestInteractive.Command.name/0","doc":"The command's name.\n\nReadable name for the command.\n\nDefaults to the `command/0`, but can be overridden to make usage output clearer.","ref":"MixTestInteractive.Command.html#c:name/0"},{"type":"callback","title":"MixTestInteractive.Command.run/2","doc":"Execute the command.\n\nPerforms the desired action in response to the command.\n\nMost commands return an `:ok` tuple with an updated configuration, allowing\n`MixTestInteractive.InteractiveMode` to run the tests with the new configuration.\n\nA command can return a `:no_run` tuple with an updated configuration if the tests\nshould not be run in response to the command.\n\nA command can return `:help` to show detailed usage information, or `:quit` to\nexit `mix test.interactive`.\n\nNo default provided.","ref":"MixTestInteractive.Command.html#c:run/2"},{"type":"type","title":"MixTestInteractive.Command.response/0","doc":"","ref":"MixTestInteractive.Command.html#t:response/0"},{"type":"module","title":"MixTestInteractive.CommandProcessor","doc":"Processes interactive mode commands.","ref":"MixTestInteractive.CommandProcessor.html"},{"type":"function","title":"MixTestInteractive.CommandProcessor.call/2","doc":"Processes a single interactive mode command.","ref":"MixTestInteractive.CommandProcessor.html#call/2"},{"type":"function","title":"MixTestInteractive.CommandProcessor.usage/1","doc":"Returns an ANSI-formatted usage summary.\n\nIncludes only commands that are applicable to the current configuration.","ref":"MixTestInteractive.CommandProcessor.html#usage/1"},{"type":"type","title":"MixTestInteractive.CommandProcessor.response/0","doc":"","ref":"MixTestInteractive.CommandProcessor.html#t:response/0"},{"type":"module","title":"MixTestInteractive.Config","doc":"Configuration for the task.","ref":"MixTestInteractive.Config.html"},{"type":"function","title":"MixTestInteractive.Config.new/0","doc":"Create a new config struct, taking values from the application environment.","ref":"MixTestInteractive.Config.html#new/0"},{"type":"type","title":"MixTestInteractive.Config.t/0","doc":"","ref":"MixTestInteractive.Config.html#t:t/0"},{"type":"module","title":"MixTestInteractive.InteractiveMode","doc":"Server for interactive mode.\n\nProcesses commands from the user and requests to run tests due to file changes.\nThis ensures that commands cannot be processed while tests are already running.\n\nAny commands that come in while the tests are running will be processed once the\ntest run has completed.","ref":"MixTestInteractive.InteractiveMode.html"},{"type":"function","title":"MixTestInteractive.InteractiveMode.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"MixTestInteractive.InteractiveMode.html#child_spec/1"},{"type":"function","title":"MixTestInteractive.InteractiveMode.command_line_arguments/2","doc":"Process command-line arguments.","ref":"MixTestInteractive.InteractiveMode.html#command_line_arguments/2"},{"type":"function","title":"MixTestInteractive.InteractiveMode.note_file_changed/1","doc":"Tell InteractiveMode that one or more files have changed.","ref":"MixTestInteractive.InteractiveMode.html#note_file_changed/1"},{"type":"function","title":"MixTestInteractive.InteractiveMode.process_command/2","doc":"Process a command from the user.","ref":"MixTestInteractive.InteractiveMode.html#process_command/2"},{"type":"function","title":"MixTestInteractive.InteractiveMode.start_link/1","doc":"Start the interactive mode server.","ref":"MixTestInteractive.InteractiveMode.html#start_link/1"},{"type":"type","title":"MixTestInteractive.InteractiveMode.option/0","doc":"","ref":"MixTestInteractive.InteractiveMode.html#t:option/0"},{"type":"module","title":"MixTestInteractive.PortRunner","doc":"Run the tasks in a new OS process via `Port`s.\n\nOn Unix-like operating systems, it runs the tests using a `zombie_killer` script\nas described in https://hexdocs.pm/elixir/Port.html#module-zombie-operating-system-processes.\nIt also enables ANSI output mode.\n\nOn Windows, `mix` is run directly and ANSI mode is not enabled, as it is not always\nsupported by Windows command processors.","ref":"MixTestInteractive.PortRunner.html"},{"type":"function","title":"MixTestInteractive.PortRunner.run/4","doc":"Run tests based on the current configuration.","ref":"MixTestInteractive.PortRunner.html#run/4"},{"type":"type","title":"MixTestInteractive.PortRunner.os_type/0","doc":"","ref":"MixTestInteractive.PortRunner.html#t:os_type/0"},{"type":"type","title":"MixTestInteractive.PortRunner.runner/0","doc":"","ref":"MixTestInteractive.PortRunner.html#t:runner/0"},{"type":"module","title":"MixTestInteractive.Runner","doc":"Runs tests based on current configuration.\n\nAlso responsible for optionally clearing the terminal and printing the current time.","ref":"MixTestInteractive.Runner.html"},{"type":"function","title":"MixTestInteractive.Runner.run/2","doc":"Run tests using configured runner.","ref":"MixTestInteractive.Runner.html#run/2"},{"type":"module","title":"MixTestInteractive.Settings","doc":"Interactive mode settings.\n\nKeeps track of the current settings of `MixTestInteractive.InteractiveMode`, making changes\nin response to user commands.","ref":"MixTestInteractive.Settings.html"},{"type":"function","title":"MixTestInteractive.Settings.all_tests/1","doc":"Update settings to run all tests, removing any flags or filter patterns.","ref":"MixTestInteractive.Settings.html#all_tests/1"},{"type":"function","title":"MixTestInteractive.Settings.cli_args/1","doc":"Assemble command-line arguments to pass to `mix test`.\n\nIncludes arguments originally passed to `mix test.interactive` when it was started\nas well as arguments based on the current interactive mode settings.","ref":"MixTestInteractive.Settings.html#cli_args/1"},{"type":"function","title":"MixTestInteractive.Settings.new/1","doc":"Create a new state struct, taking values from the command line.\n\nIn addition to its own options, new/1 initializes its interactive mode settings from some of\n`mix test`'s options (`--failed`, `--stale`, and any filename arguments).","ref":"MixTestInteractive.Settings.html#new/1"},{"type":"function","title":"MixTestInteractive.Settings.only_failed/1","doc":"Update settings to only run failing tests.\n\nCorresponds to `mix test --failed`.","ref":"MixTestInteractive.Settings.html#only_failed/1"},{"type":"function","title":"MixTestInteractive.Settings.only_patterns/2","doc":"Provide a list of file-name filter patterns.\n\nOnly test filenames matching one or more patterns will be run.","ref":"MixTestInteractive.Settings.html#only_patterns/2"},{"type":"function","title":"MixTestInteractive.Settings.only_stale/1","doc":"Update settings to only run \"stale\" tests.\n\nCorresponds to `mix test --stale`.","ref":"MixTestInteractive.Settings.html#only_stale/1"},{"type":"function","title":"MixTestInteractive.Settings.summary/1","doc":"Return a text summary of the current interactive mode settings.","ref":"MixTestInteractive.Settings.html#summary/1"},{"type":"function","title":"MixTestInteractive.Settings.toggle_watch_mode/1","doc":"Toggle file-watching mode on or off.","ref":"MixTestInteractive.Settings.html#toggle_watch_mode/1"},{"type":"type","title":"MixTestInteractive.Settings.t/0","doc":"","ref":"MixTestInteractive.Settings.html#t:t/0"},{"type":"module","title":"MixTestInteractive.Watcher","doc":"A server that runs tests whenever source files change.","ref":"MixTestInteractive.Watcher.html"},{"type":"function","title":"MixTestInteractive.Watcher.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"MixTestInteractive.Watcher.html#child_spec/1"},{"type":"function","title":"MixTestInteractive.Watcher.start_link/1","doc":"Start the file watcher.","ref":"MixTestInteractive.Watcher.html#start_link/1"},{"type":"module","title":"MixTestInteractive.Command.AllTests","doc":"Run all tests, removing any flags or filters.","ref":"MixTestInteractive.Command.AllTests.html"},{"type":"module","title":"MixTestInteractive.Command.Failed","doc":"Run only failed tests.\n\nEquivalent to `mix test --failed`.","ref":"MixTestInteractive.Command.Failed.html"},{"type":"module","title":"MixTestInteractive.Command.Help","doc":"Show detailed usage information.\n\nLists all commands applicable to the current context.","ref":"MixTestInteractive.Command.Help.html"},{"type":"module","title":"MixTestInteractive.Command.Pattern","doc":"Specify one or more filename-matching patterns.\n\nRuns all tests that contain at least one of the patterns as a substring of their filename.\n\nIf any pattern looks like a filename/line number pattern, then all of the patterns\nare passed on to `mix test` directly; no filtering is done.  This is because `mix test`\nonly supports a single filename-with-line-number pattern at a time.","ref":"MixTestInteractive.Command.Pattern.html"},{"type":"module","title":"MixTestInteractive.Command.Quit","doc":"Exit mix test.interactive.","ref":"MixTestInteractive.Command.Quit.html"},{"type":"module","title":"MixTestInteractive.Command.RunTests","doc":"Run all tests matching the current flags and filter settings.","ref":"MixTestInteractive.Command.RunTests.html"},{"type":"module","title":"MixTestInteractive.Command.Stale","doc":"Run only stale tests.\n\nEquivalent to `mix test --stale`.","ref":"MixTestInteractive.Command.Stale.html"},{"type":"module","title":"MixTestInteractive.Command.ToggleWatchMode","doc":"Toggle file-watching mode on or off.\n\nWhen watch mode is on, `mix test.interactive` will re-run the\ncurrent set of tests whenever a file changes.\n\nWhen it is off, tests must be run manually, either by changing\nusing a command to change the configuration, or by using the\n`MixTestInteractive.Command.RunTests` command.","ref":"MixTestInteractive.Command.ToggleWatchMode.html"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [Unreleased](https://github.com/randycoulman/mix_test_interactive/compare/v3.1.0...HEAD)\n\n## [v3.1.0](https://github.com/randycoulman/mix_test_interactive/compare/v3.0.0...v3.1.0) - 2024-08-24","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"- Add a new `command` configuration option that allows use of a custom command instead of `mix` for running tests. See the [README](https://github.com/randycoulman/mix_test_interactive#command-use-a-custom-command) for more details. ([#96](https://github.com/randycoulman/mix_test_interactive/pull/96))","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Added [documentation for missing configuration options](https://github.com/randycoulman/mix_test_interactive#configuration) in the README. ([#96](https://github.com/randycoulman/mix_test_interactive/pull/96))\n\n## [v3.0.0](https://github.com/randycoulman/mix_test_interactive/compare/v2.1.0...v3.0.0) - 2024-07-13","ref":"changelog.html#changed"},{"type":"extras","title":"💥 BREAKING CHANGE 💥 - Changelog","doc":"- This release drops support for Elixir 1.12. We officially support the\n  [same versions as Elixir\n  itself](https://hexdocs.pm/elixir/1.17.2/compatibility-and-deprecations.html),\n  so support for Elixir 1.12.\n  ([#94](https://github.com/randycoulman/mix_test_interactive/pull/94))\n\nThere are no actual breaking changes in the code itself, so as long as you're on\nElixir 1.13 or later, you should have no problems upgrading to this version.","ref":"changelog.html#breaking-change"},{"type":"extras","title":"Changed - Changelog","doc":"- Update to the latest version of [ex_doc](https://hexdocs.pm/ex_doc/readme.html). The [documentation](https://hexdocs.pm/mix_test_interactive/readme.html) reflects these changes. ([#93](https://github.com/randycoulman/mix_test_interactive/pull/93))\n\n## [v2.1.0](https://github.com/randycoulman/mix_test_interactive/compare/v2.0.4...v2.1.0) - 2024-07-13","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fix compiler warnings on Elixir 1.17. ([#89](https://github.com/randycoulman/mix_test_interactive/pull/89) - Thanks [@jfpedroza](https://github.com/jfpedroza)!)\n\n## [v2.0.4](https://github.com/randycoulman/mix_test_interactive/compare/v2.0.3...v2.0.4) - 2024-03-04","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Ignore some filesystem events emitted by inotify. Some events are triggered later than others and end up causing the tests to run twice for a single file change. ([#86](https://github.com/randycoulman/mix_test_interactive/pull/86) - Thanks\n  [@jwilger](https://github.com/jwilger)!)\n\n## [v2.0.3](https://github.com/randycoulman/mix_test_interactive/compare/v2.0.2...v2.0.3) - 2024-01-27","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- Update `file_system` dependency to allow versions 0.2 and 1.0 to avoid dependency conflicts with popular libraries like `phoenix_live_reload`. Previously, we'd specified v0.3, but there is no such version of `file_system`. ([#83](https://github.com/randycoulman/mix_test_interactive/pull/83))\n\n## [v2.0.2](https://github.com/randycoulman/mix_test_interactive/compare/v2.0.1...v2.0.2) - 2024-01-25","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"- Allow `file_system` versions 0.3 and 1.0 to avoid dependency conflicts with popular libraries like `phoenix_live_reload`. ([#81](https://github.com/randycoulman/mix_test_interactive/pull/81))\n\n## [v2.0.1](https://github.com/randycoulman/mix_test_interactive/compare/v2.0.0...v2.0.1) - 2024-01-25","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Make the `styler` dependency a dev-only dependency to avoid pulling it into client projects with a potential version conflict. ([#79](https://github.com/randycoulman/mix_test_interactive/pull/79))\n\n## [v2.0.0](https://github.com/randycoulman/mix_test_interactive/compare/v1.2.1...v2.0.0) - 2024-01-22","ref":"changelog.html#fixed"},{"type":"extras","title":"💥 BREAKING CHANGES 💥 - Changelog","doc":"- This release drops support for older Elixir versions. We officially support the\n  [same versions as Elixir\n  itself](https://hexdocs.pm/elixir/1.16.0/compatibility-and-deprecations.html),\n  so support for Elixir 1.11 and prior has been dropped.\n  ([#67](https://github.com/randycoulman/mix_test_interactive/pull/67),\n  [#75](https://github.com/randycoulman/mix_test_interactive/pull/75))\n- Upgrade [file_system](https://hex.pm/packages/file_system) dependency to\n  version 1.0. This appears to be a simple bump to 1.0 with no breaking changes,\n  so should be safe to upgrade to. It might break dependency resolution\n  if you're locked to a pre-1.0 version, so it's noted here.\n  ([#72](https://github.com/randycoulman/mix_test_interactive/pull/72) - Thanks\n  [@andyl](https://github.com/andyl)!)\n\nThere are no actual breaking changes, so as long as you're on Elixir 1.12 or\nlater and aren't depending on a pre-1.0 version of `file_system`, you should\nhave no problems upgrading to this version.","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Added - Changelog","doc":"- Add full task documentation. `mix help test.interactive` will now show a\n  summary of usage and configuration information ([#70](https://github.com/randycoulman/mix_test_interactive/pull/70))\n\n- Add support for newer `mix test` options ([#71](https://github.com/randycoulman/mix_test_interactive/pull/71))\n\n## [v1.2.2](https://github.com/randycoulman/mix_test_interactive/compare/v1.2.1...v1.2.2) - 2022-11-15\n\nNo functional changes; purely administrative.","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Migrated repository ownership from @influxdata to @randycoulman ([#60](https://github.com/randycoulman/mix_test_interactive/pull/60))\n\n## [v1.2.1](https://github.com/randycoulman/mix_test_interactive/compare/v1.2.0...v1.2.1) - 2022-06-01","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Include .heex in list of watched file extensions\n  ([#57](https://github.com/randycoulman/mix_test_interactive/pull/57) - Thanks @juddey!)\n\n## [v1.2.0](https://github.com/randycoulman/mix_test_interactive/compare/v1.1.0...v1.2.0) - 2022-04-07","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- Now tested against Elixir 1.12 and 1.13. ([#55](https://github.com/randycoulman/mix_test_interactive/pull/55))\n- Misc. dependency upgrades. ([#55](https://github.com/randycoulman/mix_test_interactive/pull/55))","ref":"changelog.html#changed"},{"type":"extras","title":"Documentation - Changelog","doc":"- Include proper source ref in the generated documentation so that it now points at the correct version of the source code. ([#51](https://github.com/randycoulman/mix_test_interactive/pull/51) - Thanks @kianmeng!)\n\n- Include license and changelog in generated documentation. ([#51](https://github.com/randycoulman/mix_test_interactive/pull/51) - Thanks @kianmeng!)\n\n## [v1.1.0](https://github.com/randycoulman/mix_test_interactive/compare/v1.0.1...v1.1.0) - 2021-10-08","ref":"changelog.html#documentation"},{"type":"extras","title":"Fixed - Changelog","doc":"- The `p` (pattern) command now works properly in umbrella projects. Previously, it was unable to find any test files in order to filter the pattern and would therefore not run any tests. Now, in an umbrella project, `mix test.interactive` looks for test files in `apps/*/test` by default, but still respects the `:test_paths` config option used by `mix test`. ([#48](https://github.com/randycoulman/mix_test_interactive/pull/48))","ref":"changelog.html#fixed"},{"type":"extras","title":"Documentation - Changelog","doc":"- Fixed the spelling of Louis Pilfold's name in the README. Sorry, Louis! 🤦‍♂️ ([#49](https://github.com/randycoulman/mix_test_interactive/pull/49))\n\n## [v1.0.1](https://github.com/randycoulman/mix_test_interactive/compare/v1.0.0...v1.0.1) - 2021-03-09","ref":"changelog.html#documentation"},{"type":"extras","title":"Fixed - Changelog","doc":"- Eliminates a GenServer call timeout that can occur if a command is typed while a long-running test run is in progress. ([#44](https://github.com/randycoulman/mix_test_interactive/pull/44)).\n\n## [v1.0.0](https://github.com/randycoulman/mix_test_interactive/compare/14eb50c742a042de7bfc37c41b8af68d839eb443...v1.0.0) - 2021-02-18\n\n🎉 Happy Birthday!\n\nThe following sections describe changes from [mix-test.watch](https://github.com/lpil/mix-test.watch), which served as the basis of this project.","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Interactive mode allows dynamically filtering test files based on a substring pattern or switching to run only failed or stale tests without having to restart.\n\n- File-watching mode can be turned on and off, either by passing `--no-watch` on the command line, or by using the `w` command to dynamically toggle watch mode on and off. When file-watching mode is on, tests will be run in response to file changes as with `mix-test.watch`. When off, tests must be run explicitly using the `Enter` key or by using another command that changes the set of tests to be run.","ref":"changelog.html#added"},{"type":"extras","title":"Removed - Changelog","doc":"- It is no longer possible to customize the CLI executable. We always use `mix`. Previously, this allowed the use of `iex -S mix` instead, but that doesn't work well with interactive mode.\n\n- It is no longer possible to specify multiple tasks to run on file changes. This ability added complexity and the feature didn't work very well because it assumed that all tasks would take the exact same set of command-line arguments. It is still possible to specify a different task name than `test`, but `mix test.interactive` assumes that the custom task accepts the same command-line arguments as `mix test`.","ref":"changelog.html#removed"},{"type":"extras","title":"Fixed - Changelog","doc":"- On Windows, `mix test.interactive` runs the correct `mix` task, including a custom task provided in the configuration, rather than always running `mix test`. It also passes along other provided command-line arguments as well as those injected by `mix test.interactive`.","ref":"changelog.html#fixed"},{"type":"extras","title":"License","doc":"# MIT License\n\nCopyright (c) 2021 Randy Coulman\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# mix test.interactive\n\n[![Build Status](https://github.com/randycoulman/mix_test_interactive/actions/workflows/ci.yml/badge.svg)](https://github.com/randycoulman/mix_test_interactive/actions)\n[![Module Version](https://img.shields.io/hexpm/v/mix_test_interactive.svg)](https://hex.pm/packages/mix_test_interactive)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/mix_test_interactive/)\n[![License](https://img.shields.io/hexpm/l/mix_test_interactive.svg)](https://github.com/randycoulman/mix_test_interactive/blob/master/LICENSE.md)\n\n`mix test.interactive` is an interactive test runner for ExUnit tests.\n\nBased on Louis Pilfold's wonderful [mix-test.watch](https://github.com/lpil/mix-test.watch) and inspired by Jest's interactive watch mode, `mix test.interactive` allows you to dynamically change which tests should be run with a few keystrokes.\n\nIt allows you to easily switch between running all tests, stale tests, or failed tests. Or, you can run only the tests whose filenames contain a substring. Includes an optional \"watch mode\" which runs tests after every file change.","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"The package can be installed by adding `mix_test_interactive` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:mix_test_interactive, \"~> 3.1\", only: :dev, runtime: false}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Overview","doc":"Run the mix task:\n\n```shell\nmix test.interactive\n```\n\nYour tests will run immediately (and every time a file changes).\n\nIf you don't want tests to run automatically when files change, you can start `mix test.interactive` with the `--no-watch` flag:\n\n```shell\nmix test.interactive --no-watch\n```\n\nAfter the tests run, you can use the interactive mode to change which tests will run.\n\nUse the `p` command to run only test files that match one or more provided patterns. A pattern is the project-root-relative path to a test file (with or without a line number specification) or a string that matches a portion of full pathname. e.g. `test/my_project/my_test.exs`, `test/my_project/my_test.exs:12:24` or `my`.\n\nIf any pattern contains a line number specification, all patterns are passed directly to `mix test`.\n\n```\np pattern1 pattern2\n```\n\nUse the `s` command to run only test files that reference modules that have changed since the last run (equivalent to the `--stale` option of `mix test`).\n\nUse the `f` command to run only tests that failed on the last run (equivalent to the `--failed` option of `mix test`).\n\nUse the `a` command to run all tests.\n\nUse the `w` command to turn file-watching mode on or off.\n\nUse the `Enter` key to re-run the current set of tests without requiring a file change.\n\nUse the `q` command, or press `Ctrl-D` to exit the program.","ref":"readme.html#usage"},{"type":"extras","title":"Passing Arguments To Tasks - Overview","doc":"Any command line arguments passed to the `mix test.interactive` task will be passed\nthrough to the task being run, along with any arguments added by interactive mode. If I want to see detailed trace information for my tests, I can run:\n\n```\nmix test.interactive --trace\n```\n\n`mix test.interactive` will detect the `--stale` and `--failed` flags and use those as initial settings in interactive mode. You can then toggle those flags on and off as needed. It will also detect any filename or pattern arguments and use those as initial settings. However, it does not detect any filenames passed with `--include` or `--only`. Note that if you specify a pattern on the command-line, `mix test.interactive` will find all test files matching that pattern and pass those to `mix test` as if you had used the `p` command.","ref":"readme.html#passing-arguments-to-tasks"},{"type":"extras","title":"Configuration - Overview","doc":"`mix test.interactive` can be configured with various options using application\nconfiguration.\n\n### `clear`: Clear the console before each run\n\nIf you want `mix test.interactive` to clear the console before each run, you can\nenable this option in your config/dev.exs as follows:\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    clear: true\nend\n```\n\n### `command`: Use a custom command\n\nBy default, `mix test.interactive` uses `mix test` to run tests.\n\nYou might want to provide a custom command that does other things before or\nafter running `mix`. In that case, you can customize the command used for\nrunning tests.\n\nFor example, you might want to provide a name for the test runner process to\nallow connection from other Erlang nodes. Or you might want to run other\ncommands before or after running the tests.\n\nIn those cases, you can customize the command that `mix test.interactive` will\nuse to run your tests. `mix test.interactive` assumes that the custom command\nultimately runs `mix` under the hood (or at least accepts\nall of the same command-line arguments as `mix`). The custom command can either be a string or\na `{command, [..args..]}` tuple.\n\nExamples:\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    command: \"path/to/my/test_runner.sh\"\nend\n```\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    command: {\"elixir\", [\"--sname\", \"name\", \"-S\", \"mix\"]}\nend\n```\n\nTo run a different mix task instead, see the `task` option below.\n\n### `exclude`: Excluding files or directories\n\nTo stop changes to specific files or directories from triggering test runs, you\ncan add `exclude:` regexp patterns to your config in `mix.exs`:\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    exclude: [~r/db_migration\\/.*/,\n              ~r/useless_.*\\.exs/]\nend\n```\n\nThe default is `exclude: [~r/\\.#/, ~r{priv/repo/migrations}]`.\n\n### `extra_extensions`: Watch files with additional extensions\n\nBy default, `mix test.interactive` will trigger a test run when a known Elixir\nor Erlang file has changed, but not when any other file changes.\n\nYou can specify additional file extensions to be included with the\n`extra_extensions` option.\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    extra_extensions: [\"json\"]\nend\n```\n\n`mix test.interactive` always watches files with the following extensions:\n`.erl`, `.ex`, `.exs`, `.eex`, `.leex`, `.heex`, `.xrl`, `.yrl`, and `.hrl`. To\nignore files with any of these extensions, you can specify an `exclude` regexp\n(see above).\n\n### `runner`: Use a custom runner module\n\nBy default `mix test.interactive` uses an internal module named\n`MixTestInteractive.PortRunner` to run the tests. If you want to\nrun the tests in a different way, you can supply your own runner module instead.\nYour module must implement a `run/2` function that takes a\n`MixTestInteractive.Config` struct and a list of `String.t()` arguments.\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    runner: MyApp.FancyTestRunner\nend\n```\n\n### `timestamp`: Display the current time before running the tests\n\nWhen `timestamp` is set to true, `mix test.interactive` will display the\ncurrent time (UTC) just before running the tests.\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    timestamp: true\nend\n```\n\n### `task`: Run a different mix task\n\nBy default, `mix test.interactive` runs `mix test`.\n\nThrough the mix config it is possible to run a different mix task. `mix\ntest.interactive` assumes that this alternative task accepts the same\ncommand-line arguments as `mix test`.\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    task: \"custom_test_task\"\nend\n```\n\nThe task is run with `MIX_ENV` set to `test`.\n\nTo use a custom command instead, see the `command` option above.","ref":"readme.html#configuration"},{"type":"extras","title":"Compatibility Notes - Overview","doc":"On Linux you may need to install `inotify-tools`.","ref":"readme.html#compatibility-notes"},{"type":"extras","title":"Desktop Notifications - Overview","doc":"You can enable desktop notifications with\n[ex_unit_notifier](https://github.com/navinpeiris/ex_unit_notifier).","ref":"readme.html#desktop-notifications"},{"type":"extras","title":"Acknowledgements - Overview","doc":"This project started as a clone of the wonderful [mix-test.watch](https://github.com/lpil/mix-test.watch) project, which I've used and loved for years. I've added the interactive mode features to the existing feature set.\n\nThe idea for having an interactive mode comes from [Jest](https://jestjs.io/) and its incredibly useful interactive watch mode.","ref":"readme.html#acknowledgements"},{"type":"extras","title":"Copyright and License - Overview","doc":"Copyright (c) 2021-2024 Randy Coulman\n\nThis work is free. You can redistribute it and/or modify it under the\nterms of the MIT License. See the [LICENSE.md](./LICENSE.md) file for more details.","ref":"readme.html#copyright-and-license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}